#!/usr/bin/env python
# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta

"""PAL command modules.

Define classes to implement PAL commands.
"""


import os
import sys

import ionas.nascmd as nascmd
import pal_config as config

from pal_info import Results


class PalCmdOption(nascmd.NasCmdOption):
    """PAL command option class."""

    def __init__(self, argv=sys.argv[1:], version=config.VERSION, ver_fmt=None,
            usage=None, description=None, option_list=[]):
        """Constructor."""

        nascmd.NasCmdOption.__init__(self, argv, version, ver_fmt, usage,
                            description, option_list)


class PalCmd(nascmd.NasCmd):
    """Base class for PAL command."""

    def __init__(self, option=None, logger_name=config.LOGGER_NAME,
            log=os.path.join(config.LOG_DIR, config.LOG_FILE),
            log_level=None):
        """Constructor."""

        nascmd.NasCmd.__init__(self, Results, option, logger_name,
                            log, log_level)
