#!/usr/bin/env python
# -*-  coding: utf-8 -*-

import cgi
import os
import sys
import commands
import crypt
import traceback
from xml.etree import ElementTree
from product_conf.devinfo import (NET_RAW_DEV_LIST,)

hlsc = True
hdlar_version = '1.0'
hlsc_version = '1.1'

FORM_COMMAND='command'
FORM_PINCODE='pincode'
FORM_GETINFO='getinfo'

COMMAND_CHECK_PINCODE_INIT='check_init'
COMMAND_CHECK_PINCODE_CURRENT='check_current'
COMMAND_REGIST_PINCODE_NEW='regist_new'

RESULT_SUCCESS=0
RESULT_FAILED=1
RESULT_INVALID_REQUEST=128
RESULT_EXCEPTION=256

EXEC_PINCODE_GET_INIT='/usr/local/bin/rl3_pincode.sh init'
EXEC_PINCODE_GET_CURRENT='/usr/local/bin/rl3_pincode.sh current'
EXEC_REMOTELINK3_STARTUP='sudo /usr/local/bin/HDL_remotelink3_startup'
EXEC_GET_ADMIN_PASSWD='sudo cat /etc/shadow | grep "^admin:" | cut -f 2 -d ":"'
EXEC_GET_MODEL='cat /var/lib/model | grep "^model\t" | cut -f 2 -d "\t"'

CONF_SETPASSURL='/opt/rl3/conf/setpassurl'
CONF_LOGOFFURL='/opt/rl3/conf/logoffurl'

TLIMITURL_PATH = "/remotelinkfiles/_expiration/_expiration"

PARAM_CONF_PATH='/opt/rl3/bin/conf/param.conf'
#PARAM_CONF_PATH='/mnt/hda5/conf/rl3/param.conf'
EXEC_PORT_GET_HTTP='cat ' + PARAM_CONF_PATH + '| grep TCP_LISTEN_ADDR_DEVICE_1 | sed "s/.*=//"'
EXEC_PORT_GET_HTTPS='cat ' + PARAM_CONF_PATH + '| grep TCP_LISTEN_ADDR_DEVICE_2 | sed "s/.*=//"'

SYS_MAC_ADDRESS_PATH = "/sys/class/net/%s/address" % NET_RAW_DEV_LIST[0]


def print_result(result,pincode=None,port_http=None,port_https=None,pchk=None,model=None,setpassurl=None,logoffurl=None,debug=None,tlimiturl=None,macaddress=None):
    print 'Content-type: text/html\n'
    element = ElementTree.Element('response')
    element.set('result', str(result))
    element.set('version', hdlar_version)
    if hlsc:
        element.set('version', hlsc_version)
    if pincode:
        element.set('pincode', pincode)
    if port_http:
        element.set('port_http', port_http)
    if port_https:
        element.set('port_https', port_https)
    if pchk:
        element.set('pchk', pchk)
    if model:
        element.set('model', model)
    if setpassurl:
        element.set('setpassurl', setpassurl)
    if logoffurl:
        element.set('logoffurl', logoffurl)
    if tlimiturl:
        element.set('tlimiturl', tlimiturl)
    if macaddress:
        element.set('macaddress', macaddress)
    if debug:
        element_debug = ElementTree.Element('debug')
        element_debug.text = debug
        element.append(element_debug)
    print ElementTree.tostring(element, encoding='UTF-8')
    open("/tmp/abc.log", "a").write(ElementTree.tostring(element, encoding='UTF-8') + "\n")
    return

def exec_command(command):
    (status, output) = commands.getstatusoutput(command + ' 2>/dev/null')
    if status != 0:
        raise ExecCommand
    return output

def admin_pass_empty():
    cryptedpasswd = exec_command(EXEC_GET_ADMIN_PASSWD)
    return crypt.crypt('',cryptedpasswd) == cryptedpasswd

def get_model():
    return exec_command(EXEC_GET_MODEL)

def get_setpassurl():
    if not os.path.exists(CONF_SETPASSURL):
       return None
    file = open(CONF_SETPASSURL)
    setpassurl = file.readline().strip()
    file.close()
    return setpassurl

def get_logoffurl():
    if not os.path.exists(CONF_LOGOFFURL):
       return None
    file = open(CONF_LOGOFFURL)
    logoffurl = file.readline().strip()
    file.close()
    return logoffurl

def get_macaddress():

    return open(SYS_MAC_ADDRESS_PATH).read().strip().upper().replace(":", "")


def check_init(pincode,p,model,setpassurl,logoffurl):
    if not hlsc:
        print_result(RESULT_FAILED)
        return
    print_result(RESULT_FAILED)
#    output = exec_command(EXEC_PINCODE_GET_INIT)
#    if pincode != output:
#        print_result(RESULT_FAILED)
#        return
#    print_result(RESULT_SUCCESS,None,None,None,p,model,setpassurl,logoffurl)
    return

def check_current(pincode,p,model,setpassurl,logoffurl,tlimiturl, macaddress):
    output = exec_command(EXEC_PINCODE_GET_CURRENT)
    if pincode != output:
        print_result(RESULT_FAILED)
        return
    port_http = exec_command(EXEC_PORT_GET_HTTP)
    port_https = exec_command(EXEC_PORT_GET_HTTPS)
    print_result(RESULT_SUCCESS,None,port_http,port_https,p,model,setpassurl,logoffurl,tlimiturl=tlimiturl,macaddress=macaddress)
    return

def regist_new(p,model,setpassurl,logoffurl):
    if not hlsc:
        print_result(RESULT_FAILED)
        return
    pincode_init = exec_command(EXEC_PINCODE_GET_INIT)
    pincode_current = exec_command(EXEC_PINCODE_GET_CURRENT)
    if pincode_init != pincode_current:
        print_result(RESULT_FAILED)
        return
    output = exec_command(EXEC_REMOTELINK3_STARTUP)
    pincode_current = exec_command(EXEC_PINCODE_GET_CURRENT)
    if pincode_init == pincode_current:
        print_result(RESULT_FAILED)
        return
    print_result(RESULT_SUCCESS,pincode_current,None,None,p,model,setpassurl,logoffurl)
    return

class InvalidRequest(Exception):
    pass

class ExecCommand(Exception):
    pass

try:
    if os.environ.has_key('REQUEST_METHOD'):
        if os.environ['REQUEST_METHOD'] != 'POST':
            raise InvalidRequest

    form = cgi.FieldStorage()

    if not form.has_key(FORM_COMMAND):
        raise InvalidRequest
    command = form[FORM_COMMAND].value

    if not form.has_key(FORM_PINCODE):
        raise InvalidRequest
    pincode = form[FORM_PINCODE].value

    getinfo = 'false'
    if form.has_key(FORM_GETINFO):
        getinfo = form[FORM_GETINFO].value

    output = exec_command(EXEC_PINCODE_GET_CURRENT)
    if pincode != output:
        raise InvalidRequest

    pchk = None
    model = None
    setpassurl = None
    logoffurl = None
    tlimiturl = None
    if getinfo == 'true':
        pchk = '0'
        if admin_pass_empty():
            pchk = '1'
        model = get_model()
        setpassurl = get_setpassurl()
        logoffurl = get_logoffurl()
        tlimiturl = TLIMITURL_PATH 
        macaddress = get_macaddress()
        # workaround for Remote Link Files Ver.1.01
        if setpassurl == None:
            pchk = None

    if command == COMMAND_CHECK_PINCODE_INIT:
        check_init(pincode,pchk,model,setpassurl,logoffurl)
    elif command == COMMAND_CHECK_PINCODE_CURRENT:
        check_current(pincode,pchk,model,setpassurl,logoffurl,tlimiturl,macaddress)
    elif command == COMMAND_REGIST_PINCODE_NEW:
        regist_new(pchk,model,setpassurl,logoffurl)
    else:
        raise InvalidRequest

except InvalidRequest:
    print_result(RESULT_INVALID_REQUEST)
except:
    output = traceback.format_exc()
    print_result(RESULT_EXCEPTION,None,None,None,output)
