#!/usr/bin/env python
# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta

"""Python scrept for executing apache2 reload."""

import os
import sys
import time

from iobase.cmdexec import (CmdExec,)

STATUS_FILE_PATH = "/var/tmp/status/system"
UPDATING_STATUS = "updating"

APACHE2_RESTART_ARGS = ["/etc/init.d/apache2", "restart"]


#
# Main
#

if os.fork() != 0:
    sys.exit(0)

os.setsid()
if os.fork() != 0:
    sys.exit(0)

null_fd = os.open("/dev/null", os.O_RDWR)
for fd in (0, 1, 2):
    try:
        os.close(fd)
        os.dup2(null_fd, fd)
    except:
        pass

for fd in range(3, 20):
    try:
        os.close(fd)
    except:
        # Ignore error
        pass

while True:
    with open(STATUS_FILE_PATH) as status_file:
        status = status_file.read().strip()
        if status != UPDATING_STATUS:
            break
        time.sleep(1)

time.sleep(3)
CmdExec(APACHE2_RESTART_ARGS).execute()
