# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta

"""PAL commands information module.

Note : DO NOT EDIT.  This is automatically generated.
"""

import os
import glob
import sys

from product_conf import (PYTHON_LIB_DIR,)
from product_conf.reqinfo import (ReqTypes, Results)


# Import information module for package
def __import_addon():
    """Import addon modules installed by each package."""

    try:
        ADDON_DIR = "pkgaddon"
        package_info_list = glob.glob(os.path.join(PYTHON_LIB_DIR,
                                        ADDON_DIR, "pal_*_info.py"))

        if len(package_info_list) > 0:
            for package_info in package_info_list:
                mod_name = os.path.splitext(os.path.basename(package_info))[0]

                try:
                    module = __import__(ADDON_DIR + "." + mod_name, globals(),
                                            locals(), [""])
                
                    for attr_name in dir(module):
                        if not attr_name.startswith("_"):
                            setattr(sys.modules[__name__], attr_name, 
                                    getattr(module, attr_name))
                except:
                    # Ignore all errors
                    pass
    except:
        # Ignore all errors
        pass


__import_addon()


# Base XML string for each request to PAL/FAL commands.
PAL_CONFFILE_REQ_BASE_XML = {
        "load": "",
        "save": "",
    }

PAL_PROXY_REQ_BASE_XML = {
        "query": "<proxy><url/></proxy>"
    }

PAL_NETWORK_REQ_BASE_XML = {
        "query": "<network/>",
        "apply": "<network/>",
    }

PAL_PACKAGES_REQ_BASE_XML = {
        "install": "<packages><package><internalname/></package></packages>",
        "uninstall": "<packages><package><internalname/></package></packages>",
    }

PAL_URLACCESS_REQ_BASE_XML = {
        "send": "<urlaccess><url/></urlaccess>",
        "receive": "<urlaccess><url/></urlaccess>",
        "get": "<urlaccess><url/></urlaccess>",
    }

PAL_EVENTS_REQ_BASE_XML = {
        "register": "<events><eventinfo/></events>",
        "unregister": "<events><eventinfo/></events>",
        "event": "<events><eventinfo/></events>",
    }

PAL_SERVICECTRL_REQ_BASE_XML = {
        "query": "<servicectrl><servicelist/></servicectrl>",
        "start": "<servicectrl><servicelist/></servicectrl>",
        "stop": "<servicectrl><servicelist/></servicectrl>",
        "suspend": "<servicectrl><servicelist/></servicectrl>",
        "resume": "<servicectrl><servicelist/></servicectrl>",
    }

PAL_STATEMGR_REQ_BASE_XML = {
        "query": "<statemgr><statelist/></statemgr>",
        "set": "<statemgr><state/></statemgr>",
        "change": "<statemgr><state/></statemgr>",
    }


PAL_LED_REQ_BASE_XML = {
        "control": "<led/>",
    }


# Installed PAL commands path.
INSTALL_PATH = "/mnt/data/bin"

PAL_CONFFILE_PATH = INSTALL_PATH + "/pal_conffile.py"
PAL_GROUPS_PATH = INSTALL_PATH + "/pal_groups.py"
PAL_SYSTEMLOG_PATH = INSTALL_PATH + "/pal_systemlog.py"
PAL_VOLCTRL_PATH = INSTALL_PATH + "/pal_volctrl.py"
PAL_SNMP_PATH = INSTALL_PATH + "/pal_snmp.py"
PAL_CROND_PATH = INSTALL_PATH + "/pal_crond.py"
PAL_DEVCTRL_PATH = INSTALL_PATH + "/pal_devctrl.py"
PAL_LUMPREGIST_PATH = INSTALL_PATH + "/pal_lumpregist.py"
PAL_WINBIND_PATH = INSTALL_PATH + "/pal_winbind.py"
PAL_LOCKKEY_PATH = INSTALL_PATH + "/pal_lockkey.py"
PAL_UPS_PATH = INSTALL_PATH + "/pal_ups.py"
PAL_PROXY_PATH = INSTALL_PATH + "/pal_proxy.py"
PAL_POWER_PATH = INSTALL_PATH + "/pal_power.py"
PAL_LED_PATH = INSTALL_PATH + "/pal_led.py"
PAL_URLACCESS_PATH = INSTALL_PATH + "/pal_urlaccess.py"
PAL_NETATALK_PATH = INSTALL_PATH + "/pal_netatalk.py"
PAL_SYSINFO_PATH = INSTALL_PATH + "/pal_sysinfo.py"
PAL_REPLICATION_PATH = INSTALL_PATH + "/pal_replication.py"
PAL_SERVICECTRL_PATH = INSTALL_PATH + "/pal_servicectrl.py"
PAL_DATETIME_PATH = INSTALL_PATH + "/pal_datetime.py"
PAL_EVENTS_PATH = INSTALL_PATH + "/pal_events.py"
PAL_QUOTA_PATH = INSTALL_PATH + "/pal_quota.py"
PAL_SHARES_PATH = INSTALL_PATH + "/pal_shares.py"
PAL_PROFTPD_PATH = INSTALL_PATH + "/pal_proftpd.py"
PAL_SELFCHECK_PATH = INSTALL_PATH + "/pal_selfcheck.py"
PAL_DROPBOX_PATH = INSTALL_PATH + "/pal_dropbox.py"
PAL_LCM_PATH = INSTALL_PATH + "/pal_lcm.py"
PAL_PACKAGES_PATH = INSTALL_PATH + "/pal_packages.py"
PAL_INITIALIZE_PATH = INSTALL_PATH + "/pal_initialize.py"
PAL_AMAZONS3_PATH = INSTALL_PATH + "/pal_amazons3.py"
PAL_NETWORK_PATH = INSTALL_PATH + "/pal_network.py"
PAL_BACKUPS_PATH = INSTALL_PATH + "/pal_backups.py"
PAL_NOTICE_PATH = INSTALL_PATH + "/pal_notice.py"
PAL_DISKCTRL_PATH = INSTALL_PATH + "/pal_diskctrl.py"
PAL_FIRMWARE_PATH = INSTALL_PATH + "/pal_firmware.py"
PAL_PRINTER_PATH = INSTALL_PATH + "/pal_printer.py"
PAL_AZURE_PATH = INSTALL_PATH + "/pal_azure.py"
PAL_BUZZER_PATH = INSTALL_PATH + "/pal_buzzer.py"
PAL_STATEMGR_PATH = INSTALL_PATH + "/pal_statemgr.py"
PAL_USERS_PATH = INSTALL_PATH + "/pal_users.py"
PAL_ECO_PATH = INSTALL_PATH + "/pal_eco.py"
PAL_SAMBA_PATH = INSTALL_PATH + "/pal_samba.py"
PAL_QRCODE_PATH = INSTALL_PATH + "/pal_qrcode.py"
PAL_MAILSEND_PATH = INSTALL_PATH + "/pal_mailsend.py"
PAL_RAIDCTRL_PATH = INSTALL_PATH + "/pal_raidctrl.py"
